# This file was automatically generated by SWIG (http://www.swig.org).
# Version 2.0.9
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.



from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_tetmesh', [dirname(__file__)])
        except ImportError:
            import _tetmesh
            return _tetmesh
        if fp is not None:
            try:
                _mod = imp.load_module('_tetmesh', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _tetmesh = swig_import_helper()
    del swig_import_helper
else:
    import _tetmesh
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


def rectangle_collar(npoints, start_vertex = 0, offset = 0):
    """ Makes a collar of length npoints using rectangles
    
    @param npoints      : The number of points in one circle
    @param start_vertex : Defines the number of the first vertex in the collar.
    @param offset       : The differences in points between the two circles
    """
    for i in xrange(npoints):
        yield [i + start_vertex,
               (i+1) % npoints + start_vertex,
               ((i + npoints + 1 ) % npoints) + npoints + offset + start_vertex,
               i + npoints + offset + start_vertex]

def triangle_collar(npoints, start_vertex = 0, offset = 0):
    """ Makes a collar of length npoints using triangles
    
    @param npoints      : The number of points in one circle
    @param start_vertex : Defines the number of the first vertex in the collar.
    @param offset       : The differences in points between the two circles
    """
    for i in xrange(npoints):
        yield [[i + start_vertex,
                (i+1) % npoints + start_vertex,
                ((i + npoints + 1 ) % npoints) + npoints + offset + start_vertex],
               
               [i + start_vertex,
                i + npoints + offset + start_vertex,
                ((i + npoints + 1 ) % npoints) + npoints + offset + start_vertex] ]

class PLCEditor(_object):
    """Proxy of C++ tritetmesh::PLCEditor class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, PLCEditor, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, PLCEditor, name)
    __repr__ = _swig_repr
    __swig_destroy__ = _tetmesh.delete_PLCEditor
    __del__ = lambda self : None;
    def __init__(self): 
        """
        __init__(self) -> PLCEditor

        Destructor. 
        """
        this = _tetmesh.new_PLCEditor()
        try: self.this.append(this)
        except: self.this = this
    def clear(self):
        """
        clear(self)

        Clear the registered PLC data. 
        """
        return _tetmesh.PLCEditor_clear(self)

    def print_vertices(self):
        """
        print_vertices(self)

        Print all vertices. 
        """
        return _tetmesh.PLCEditor_print_vertices(self)

    def register_vertices(self, *args):
        """
        register_vertices(self, x_coord, y_coord, z_coord)

        Register vertices by their coordinates.

        Add vertices to the PLC by giving the coordinates in three different
        array(vector) parameters.

        The coordinate lists have to be the same size.

        Parameters:
        -----------

        x_coord:  A sequence with the x coordinates

        y_coord:  A sequence with the y coordinates

        z_coord:  A sequence with the z coordinates 
        """
        return _tetmesh.PLCEditor_register_vertices(self, *args)

    def add_vertex_marker(self, *args):
        """
        add_vertex_marker(self, marker, vertices)

        Add a marker to the supplied vector of vertices.

        Parameters:
        -----------

        marker:  The marker (integer)

        vertices:  A sequence with the vertices 
        """
        return _tetmesh.PLCEditor_add_vertex_marker(self, *args)

    def add_facet(self, *args):
        """
        add_facet(self, polygon, marker=0, max_area=-1.0)
        add_facet(self, polygon, marker=0)
        add_facet(self, polygon)

        Add a new facet to the PLC.

        The facet is added by registering a polygon. This is provided as a
        sequence of vertex numbers. Additional polygons can be added to this
        facet by the function add_polygon_to_last_facet()

        Optionally a facet marker and a maximum area for the sub faces on this
        facet can be provided.

        Parameters:
        -----------

        polygon:  A sequence of vertex numbers defining the polygon

        marker:  An integer number that is inherited by subfaces of this facet

        max_area:  A positive float that sets an upper bound on the area of
        each sub face of this facet 
        """
        return _tetmesh.PLCEditor_add_facet(self, *args)

    def add_polygon_to_last_facet(self, *args):
        """
        add_polygon_to_last_facet(self, polygon)
        add_polygon_to_last_facet(self, polygon, point)

        Add a polygon and a hole to the last registered facet.

        The polygon is provided as a sequence of vertex numbers and the hole
        is provided as a point situated on the facet.

        Parameters:
        -----------

        polygon:  A sequence of vertex numbers defining the polygon

        point:  A sequence of length 3, containing the coordinates of the
        point 
        """
        return _tetmesh.PLCEditor_add_polygon_to_last_facet(self, *args)

    def add_polygon_to_facet(self, *args):
        """
        add_polygon_to_facet(self, polygon, facet_ind, as_a_hole=False)
        add_polygon_to_facet(self, polygon, facet_ind)

        Add a polygon to a facet.

        The polygon is provided as a sequence of vertex numbers. If as_a_hole
        is true then the polygon is added as a hole, using the mid point
        values of the vertices

        Parameters:
        -----------

        polygon:  A sequence of vertex numbers defining the polygon

        facet_ind:  The facet index

        as_a_hole:  True if the polygon should be interpreted as a facet hole

        """
        return _tetmesh.PLCEditor_add_polygon_to_facet(self, *args)

    def add_facet_hole(self, *args):
        """
        add_facet_hole(self, point)
        add_facet_hole(self, point, facet_ind)

        Add a hole to the last registered facet.

        The hole is provided as a point situated on the facet.

        Parameters:
        -----------

        point:  A sequence of length 3, containing the coordinates of the
        point

        facet_ind:  The facet index 
        """
        return _tetmesh.PLCEditor_add_facet_hole(self, *args)

    def add_facet_marker(self, *args):
        """
        add_facet_marker(self, marker)
        add_facet_marker(self, marker, facet_ind)

        Add a marker to a given facet.

        Parameters:
        -----------

        marker:  An integer number that is inherited by subfaces of this facet

        facet_ind:  An integer number defining the facet. 
        """
        return _tetmesh.PLCEditor_add_facet_marker(self, *args)

    def add_facet_area_constraints(self, *args):
        """
        add_facet_area_constraints(self, max_area)
        add_facet_area_constraints(self, max_area, facet_ind)

        Add an area constraint for the subfaces of a given facet.

        Parameters:
        -----------

        max_area:  A positive float that sets an upper bound on the area of
        each sub face of this facet

        facet_ind:  An integer number defining the facet. 
        """
        return _tetmesh.PLCEditor_add_facet_area_constraints(self, *args)

    def add_hole(self, *args):
        """
        add_hole(self, point)

        Add a hole to the PLC.

        The hole is provided as a point situated inside the PLC. Make sure
        that the point is sourrounded by facets. The mesh can otherwise
        dissapear!

        Parameters:
        -----------

        point:  A sequence of length 3, containing the coordinates of the
        point 
        """
        return _tetmesh.PLCEditor_add_hole(self, *args)

    def add_region(self, *args):
        """
        add_region(self, point, attribute, max_volume=-1.0)
        add_region(self, point, attribute)

        Add a region to the PLC.

        The region is provided as a point situated inside the PLC together
        with an attribute. All tetrahedrons situated inside the region defined
        by any sourrounding facets will inherit this attribute.

        Optionally a maximal volume can be provided limiting the volume of the
        tetrahedrons inside the region.

        Parameters:
        -----------

        point:  A sequence of length 3, containing the coordinates of the
        point

        attribute:  A float defining the attribute of the tetrahedrons inside
        the region

        max_volume:  A float definging the maximal volume of the tetrahedrons
        inside the region 
        """
        return _tetmesh.PLCEditor_add_region(self, *args)

    def build(self, *args):
        """
        build(self, file_name, save_tetgen=False, save_off=False)
        build(self, file_name, save_tetgen=False)
        build(self, file_name)
        build(self)

        Build the mesh.

        The mesh is builded using either the information in any loaded plc or
        by the registered plc information. 
        """
        return _tetmesh.PLCEditor_build(self, *args)

    def save_mesh(self, *args):
        """
        save_mesh(self, file_name, save_tetgen=False, save_off=False)
        save_mesh(self, file_name, save_tetgen=False)
        save_mesh(self, file_name)

        Save mesh to file in dolfin format. 
        """
        return _tetmesh.PLCEditor_save_mesh(self, *args)

    def test_plc(self):
        """
        test_plc(self)

        Use tetgen to detect self-intersections of facets of the PLC. 
        """
        return _tetmesh.PLCEditor_test_plc(self)

    def print_tetgen_help(self):
        """
        print_tetgen_help(self)

        Print tetgen help. 
        """
        return _tetmesh.PLCEditor_print_tetgen_help(self)

    def num_facets(self):
        """
        num_facets(self) -> unsigned int

        Print the number of registered facets. 
        """
        return _tetmesh.PLCEditor_num_facets(self)

    def load(self, *args):
        """
        load(self, file_name)

        Wrapper functions for the plc.

        Load plc from file. Accepted file formats are: poly, smesh, off, ply,
        stl, mesh 
        """
        return _tetmesh.PLCEditor_load(self, *args)

    def save_plc(self, *args):
        """
        save_plc(self, file_name)

        Write plc to file in tetgen format. 
        """
        return _tetmesh.PLCEditor_save_plc(self, *args)

    def print_parameters(self):
        """
        print_parameters(self)

        Print parameters for building mesh. 
        """
        return _tetmesh.PLCEditor_print_parameters(self)

    def set_radius_edge_ratio(self, *args):
        """
        set_radius_edge_ratio(self, ratio)

        Set quality of generated mesh. 
        """
        return _tetmesh.PLCEditor_set_radius_edge_ratio(self, *args)

    def set_uniform_volume_constraint(self, *args):
        """
        set_uniform_volume_constraint(self, constraint)

        Set uniform volume constraint. 
        """
        return _tetmesh.PLCEditor_set_uniform_volume_constraint(self, *args)

    def set_verbosity(self, *args):
        """
        set_verbosity(self, verbosity)

        Set verbosity. 
        """
        return _tetmesh.PLCEditor_set_verbosity(self, *args)

    def set_splitting_of_facets(self, *args):
        """
        set_splitting_of_facets(self, split)

        Supress splitting of facets. 
        """
        return _tetmesh.PLCEditor_set_splitting_of_facets(self, *args)

PLCEditor_swigregister = _tetmesh.PLCEditor_swigregister
PLCEditor_swigregister(PLCEditor)

# This file is compatible with both classic and new-style classes.


